
/*!
 **************************************************************************************
 * \file
 *    nal.h
 * \brief
 *    NAL related headers
 *
 * \date 4 Agust 2008
 * \author
 *    Main contributors (see contributors.h for copyright, address and affiliation details)
 *      - Karsten Suehring
 *      - Alexis Michael Tourapis         <alexismt@ieee.org> 
 ***************************************************************************************
 */


#ifndef _NAL_H_
#define _NAL_H_

#include "nalucommon.h"
//#include "enc_statistics.h"

//extern int  addCabacZeroWords(VideoParameters *p_Vid, NALU_t *nalu, StatParameters *cur_stats);
//extern void SODBtoRBSP (Bitstream *currStream);
//extern int  RBSPtoEBSP(byte *NaluBuffer, unsigned char *rbsp, int rbsp_size);

/*
 * NAL header
 */
typedef struct nal_hdr{
    u_int8 f:1;      /* Forbidden_zero_bit */
    u_int8 nri:2;    /* nal_ref_idc */
    u_int8 type:5;   /* nal_unit_payload type */
} nal_hdr_t;

typedef struct fu_hdr{
    u_int8 s:1;      /* Forbidden_zero_bit */
    u_int8 e:1;      /* Forbidden_zero_bit */
    u_int8 r:1;      /* Forbidden_zero_bit */
    u_int8 type:5;   /* nal_unit_payload type */
} fu_hdr_t;

#endif
