//
//  hist.cpp
//  iptv tools
//
//  Created by Tamás Jursonovics on 2013.06.30..
//  Copyright (c) 2013 Tamás Jursonovics. All rights reserved.
//
//  A simple tool to create histograms
//


#include <iostream>
#include <fstream>
#include <math.h>
#include <stdlib.h>     /* calloc, exit, free */


using namespace std;


ifstream in_stream;

double low,high,width;


int main(int argc, const char * argv[])
{
    if (argc!=5)
    {
        cout << "Simple histogram" << endl<<endl;
        //                              1     2             4
        cout<<"Usage: "<<argv[0]<<" <low> <high> <width> <file>"<<endl<<endl;        
        return 0;
    }
    
    sscanf(argv[1],"%lf",&low);
    sscanf(argv[2],"%lf",&high);
    sscanf(argv[3],"%lf",&width);
        
    //2. Initialize file
    in_stream.open(argv[4]);
    if (in_stream.fail() )
    {
        cerr<<"Error opening the file " << argv[4] << ":" << strerror(errno);
        
        return -1;
    }
    

    double *hist=(double*)malloc((int)ceil((high-low)/width)*sizeof(double));
    for(int i=0;i<ceil((high-low)/width);i++)
        hist[i]=0;
    
    double x;
    char line[256];
    while(in_stream.good())
    {
        in_stream.getline(line,256);
        sscanf(line,"%lf",&x);
        if((x>=low) && (x<high))
            hist[(int)floor((x-low)/width)]++;
    }
    
    //Summarize
    double sum=0;
    for(int i=0;i<ceil((high-low)/width);i++)
    {
//        if( hist[i]==0 )
//            hist[i]=hist[i-1];
        sum += hist[i];
    }

    for(int i=0;i<ceil((high-low)/width);i++)
        hist[i] /= (sum*width);
    
    for(int i=0;i<ceil((high-low)/width);i++)
        printf("%05d %0.15f\n",(int)(i*width+low),hist[i]);
    
    in_stream.close();

    free(hist);
    return 0;
}

