//
//  mse.cpp
//  iptv tools
//
//  Created by Tamás Jursonovics on 2013.06.24..
//  Copyright (c) 2013 Tamás Jursonovics. All rights reserved.
//
//  A simple tool to calculate the inter-frame differences for calculation d[k]


#include <iostream>
#include <fstream>
#include <math.h>


using namespace std;


unsigned char* frame;


int main(int argc, const char * argv[])
{

    if (argc!=4)
    {   //                             1    2         3
        cout<<"Usage: "<<argv[0]<<" <width> <height> <reference.yuv>"<<endl;
        return -1;
    }
    
    //Initialie file
    ifstream ref(argv[3], ifstream::in);
    if (ref.fail() )
    {
        cout<<"Error opening the file "<<argv[3]<<endl;
        return -1;
    }
    
    unsigned int x=0,y=0;
    sscanf(argv[1],"%d",&x);
    sscanf(argv[2],"%d",&y);

    cout << "#x    = "<<x<<endl;
    cout << "#y    = "<<y<<endl;
    cout << "#file = "<<argv[3]<<endl;

    int fsize = x * y * 3 / 2;
    int ysize = x * y;

    
    //1. get length of file:
    ref.seekg (0,ref.end);
    streampos length = ref.tellg();
    ref.seekg (0,ref.beg);
    cout << "#length= "<<length<<endl<<"#"<<endl;

    
    
    //2. fill up memory
    char* a=(char*)malloc(fsize);
    char* b=(char*)malloc(fsize);

    float mse,psnr;
    printf("# k          d[k]     d[k] [PSNR]");
    printf("\n");
    
    ref.read(a,fsize);
    for(int k=1;k<length/fsize;k++)
    {
        printf("%05d ",k);
        ref.read(b,fsize);
        
        mse=0;
        for(int i=0;i<ysize;i++)
        {
            mse += ((a[i]-b[i])*(a[i]-b[i]));
        }
        mse/=(x*y);
        psnr= 10 * log10(255 * 255 / mse);
        printf("%14f %10f",mse,psnr);
        printf("\n");
        
        memcpy(a,b,fsize);
    }
    
    ref.close();
    free(a);
    free(b);
    
    return 0;
}
